/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18313
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/
#include <stdio.h>
#include <stdlib.h>
#include "mcc_generated_files/mcc.h"
#include "lcd_lib2.h"
#include "i2c_lib2.h"

#define SW RA0                 // [h؂ւRA0蓖

// O[oϐ錾
unsigned int i,j,p;

// vg^CsO錾
void KuKu_SEQ(void);             // V[PV[h֐
void KuKu_RND(void);             // _[h֐
void LCD_OUT(void);             // LCDo͊֐ 

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);             // t\Wo͊֐Ƃ
}

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    lcd_init();             // LCD
    
    while (1)
    {
        // Add your application code

        //[hI        
        if(SW == 0)    
            KuKu_SEQ();         // SW:OFFȂV[PV[h
        else
            KuKu_RND();         // SW:ONȂ烉_[h        
    }
}

void KuKu_SEQ(void)             // V[PV[h֐
{
    for(j=1; j<10; j++) {
        for(i=1; i<10; i++) {
            p = j * i;          // ㏸
            LCD_OUT();          // LCDo͊֐Ăяo
        }
    }    

    for(j=9; j>0; j--) {
        for(i=9; i>0; i--) {
            p = j * i;          // ~
            LCD_OUT();          // LCDo͊֐Ăяo
        }
    }        
}

void KuKu_RND(void)             // _[h֐
{
    i = rand() % 9 + 1;          // rand֐1~9̗𐶐
    j = rand() % 9 + 1;          // rand֐1~9̗𐶐 
    
    p = j * i;          // vZ
    LCD_OUT();          // LCDo͊֐Ăяo
}

void LCD_OUT(void)              // LCDo͊֐
{
    lcd_cmd(0x80);                  // LCD1s
    printf("%1d x %1d =", j,i);       // ㎮
    __delay_ms(500);       // 0.5 sec҂                   

    lcd_cmd(0xC0);                  // LCD2s
    printf("%2d", p);       //               
    __delay_ms(500);       // 0.5 sec҂                
}

/**
 End of File
*/